/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>

#include "fileops.h"

extern char
*homedir(void)
{
	char *home = getenv("HOME");

	if (home != NULL) {
		return home;
	} else {
		struct passwd *pw = getpwuid(getuid());
		if (pw != NULL) {
			return pw->pw_dir;
		} else {
			return NULL;
		}
	}
}


extern int
isdir(const char *s)
{
	struct stat st;

	if ((!s) || (!*s))
		return 0;
	if (stat(s, &st) < 0)
		return 0;
	if (S_ISDIR(st.st_mode))
		return 1;

	return 0;
}

extern void
check_for_home_path(char *path)
{
	char buf[BUFSIZ+1];

	sprintf(buf, "%s/%s", homedir(), path);
	if (!isdir(buf)) {
		printf("Creating LDic dir:%s\n", buf);
		if (mkdir(buf, 0755) < 0) {
			printf("Could not create dir:%s\n", buf);
		}
	}
}
