/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>
#include <malloc.h>

/* strmalloc: src nŭ Ͽ ڿ ȯ
 */
static char
*strmalloc(const char *src, size_t n)
{
	static char *dest;

	dest = (char *)malloc(n+1);
	if (dest == NULL)
		return NULL;
	
	memset(dest, '\0', n+1);
	memcpy(dest, src, n);

	return dest;
}

/* tagList: orig ˻ start ϴ tag ã  ȯ
 */
extern char
**TagList(const char *orig, const char *start, size_t n)
{
	int list_pos = 0;
	int boolTag = 0;
	int tag_pos = 0;
	int orig_pos = 0;
	char orig_ch;
	char *copy_orig;
	static char *list[BUFSIZ+1];
	
	if (orig == NULL)
		return NULL;

	copy_orig = (char *)malloc(strlen(orig)+1);
	if (copy_orig == NULL || n == 0)
		return NULL;

	memset(copy_orig, '\0', strlen(orig)+1);
	strcpy(copy_orig, orig);
	while ((orig_ch = *(copy_orig+orig_pos)) != '\0') {
		if (orig_ch == '<' ||  (orig_ch == '&' && *(copy_orig+orig_pos+1) != '[')) {
			tag_pos = orig_pos;
			boolTag = 1;
		} else if ((orig_ch == '>' || orig_ch == ';') && boolTag == 1) {
			int tag_length;

			boolTag = 0;
			tag_length = (orig_pos+1) - tag_pos;
			if (tag_length > 0) {
				char *buf;
				buf = strmalloc(copy_orig+tag_pos, tag_length);
				if (n < 0 && strcmp(buf, start) == '\0') {
					list[list_pos] = strmalloc(buf, strlen(buf));
					list_pos++;
				} else if (n > 0 && strncmp(buf, start, n) == '\0') {
					list[list_pos] = strmalloc(buf, strlen(buf));
					list_pos++;
				}
				free(buf);
			}
		}
		orig_pos++;
	}
	list[list_pos] = NULL;
	free(copy_orig);
	
	return list; /* ڿ 迭 */
}

/* TagAndTextList: orig tag text иϿ, ڿ 迭 ȯ
 */
extern char
**TagAndTextList(const char *orig)
{
	int list_pos = 0;
	int boolTag = 0;
	int tag_pos = 0;
	int text_pos = 0;
	int orig_pos = 0;
	char orig_ch;
	char *copy_orig;
	static char *list[BUFSIZ+1];
	
	if (orig == NULL)
		return NULL;

	copy_orig = (char *)malloc(strlen(orig)+1);
	if (copy_orig == NULL)
		return NULL;

	memset(copy_orig, '\0', strlen(orig)+1);
	strcpy(copy_orig, orig);
	text_pos = orig_pos;
	while ((orig_ch = *(copy_orig+orig_pos)) != '\0') {
		if (orig_ch == '<' ||  (orig_ch == '&' && *(copy_orig+orig_pos+1) != '[')) {
			int text_length;
			
			tag_pos = orig_pos;
			boolTag = 1;
			text_length = orig_pos - text_pos;
			if (text_length > 0) {
				list[list_pos] = strmalloc(copy_orig+text_pos, text_length);
				list_pos++;
			}
		} else if ((orig_ch == '>' || orig_ch == ';') && boolTag == 1) {
			int tag_length;
			
			text_pos = orig_pos + 1;
			boolTag = 0;
			tag_length = (orig_pos+1) - tag_pos;
			if (tag_length > 0) {
				list[list_pos] = strmalloc(copy_orig+tag_pos, tag_length);
				list_pos++;
			}
		}
		orig_pos++;
	}
	list[list_pos] = NULL;
	free(copy_orig);
	
	return list; /* ڿ 迭 */
}
