/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "wlist.h"

/* newitem: offset word  ο ׸ 
 */
extern WList
*newitem(int num, long offset, const char *word)
{
	WList *newp;

	newp = (WList *)malloc(sizeof(WList));

	newp->num = num;
	newp->offset = offset;
	newp->word = (char *)malloc(strlen(word)+1);
	strcpy(newp->word, word);
	newp->next = NULL;

	return newp;
}

/* addfront: newp listp  տ 
 */
extern WList
*addfront(WList *listp, WList *newp)
{
	newp->next = listp;
	return newp;
}

/* freeall: listp ִ  Ҹ 
 */
extern void
freeall(WList *listp)
{
	WList *next;

	for ( ; listp != NULL; listp = next) {
		next = listp->next;
		free(listp->word);
		free(listp);
	}
}

/* ListSearchWord: Ʈ ܾ ˻
 */
extern WList
*ListSearchWord(WList *listp, const char *word)
{
	for ( ; listp != NULL; listp = listp->next) {
		if (strcasecmp(word, listp->word) == '\0')
			return listp;
	}

	return NULL; /* ã  */
}
